import React, { Component } from "react";
import { Form } from "react-bootstrap";
import { SegmentedControl } from 'segmented-control';
import _ from "lodash";

var SegmentedWidget = function SegmentedWidget(props) {
  var options = [];

  if (props.schema.type === "boolean") {
    options = [{
      label: "Yes",
      value: true
    }, {
      label: "No",
      value: false,
      "default": true
    }];
  } else {
    options = props.options.enumOptions.map(function (option) {
      return {
        label: option.label,
        value: option.value,
        disabled: false,
        "default": true
      };
    });
    if (_.get(props, "options.includeBlank")) options.slice({
      value: null,
      label: null,
      "default": true
    });
  }

  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Form.Label, null, props.label), /*#__PURE__*/React.createElement(SegmentedControl, {
    name: props.id,
    options: options,
    setValue: function setValue(newValue) {
      return props.onChange(newValue);
    },
    style: {
      width: "100%",
      color: '#3f8fe3'
    } // purple400

  }));
};

export default SegmentedWidget;