"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _utils = require("@rjsf/core/lib/utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var CheckboxDetailField = /*#__PURE__*/function (_Component) {
  _inheritsLoose(CheckboxDetailField, _Component);

  function CheckboxDetailField(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      title: props.schema.title,
      value: props.value || props.formData || {
        checked: undefined,
        detail: null
      },
      detail_required: false
    };
    return _this;
  }

  var _proto = CheckboxDetailField.prototype;

  _proto.handleCheckBoxChange = function handleCheckBoxChange(event) {
    var _this2 = this;

    var checked = event.target.checked;
    var detail = checked ? this.state.value.detail : null;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue,
      detail_required: checked
    }, function () {
      return _this2.props.onChange(newValue);
    });
    return;
  };

  _proto.handleDetailChange = function handleDetailChange(event) {
    var _this3 = this;

    var checked = true;
    var detail = event.target.value;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue
    }, function () {
      return _this3.props.onChange(newValue);
    });
    return;
  };

  _proto.render = function render() {
    var _this4 = this;

    var _this$props = this.props,
        schema = _this$props.schema,
        idSchema = _this$props.idSchema,
        disabled = _this$props.disabled,
        readonly = _this$props.readonly,
        autofocus = _this$props.autofocus,
        onBlur = _this$props.onBlur,
        onFocus = _this$props.onFocus,
        registry = _this$props.registry;
    var DescriptionField = registry.fields.DescriptionField;
    var detail_required = this.state.detail_required;
    var required = (0, _utils.schemaRequiresTrueValue)(schema);
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "field-checkbox-detail"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, this.title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "mb-1 checkbox " + (disabled || readonly ? "disabled" : "")
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "mb-1"
    }, this.props.schema.title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group mb-3"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group-prepend"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group-text"
    }, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      className: "",
      id: idSchema && idSchema.$id,
      checked: typeof this.state.value.checked === "undefined" ? false : this.state.value.checked,
      required: required,
      disabled: disabled || readonly,
      autoFocus: autofocus,
      onChange: function onChange(event) {
        return _this4.handleCheckBoxChange(event);
      },
      onBlur: onBlur && idSchema && function (event) {
        return onBlur(idSchema.$id, event.target.checked);
      },
      onFocus: onFocus && idSchema && function (event) {
        return onFocus(idSchema.$id, event.target.checked);
      }
    }))), /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      className: "form-control",
      "aria-label": "Details",
      required: detail_required,
      value: this.state.value.detail ? this.state.value.detail : "",
      disabled: disabled || readonly || !this.state.value.checked,
      onChange: function onChange(event) {
        return _this4.handleDetailChange(event);
      },
      placeholder: schema.placeholder
    })), this.props.schema.description && /*#__PURE__*/_react["default"].createElement(DescriptionField, {
      description: this.props.schema.description
    })));
  };

  return CheckboxDetailField;
}(_react.Component);

;
var _default = CheckboxDetailField;
exports["default"] = _default;
module.exports = exports.default;