"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactGridLayout = require("react-grid-layout");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ResponsiveGridLayout = (0, _reactGridLayout.WidthProvider)(_reactGridLayout.Responsive);
var DEFAULT_COLS = {
  lg: 36,
  md: 24,
  sm: 6,
  xs: 2,
  xxs: 1
};
var DEFAULT_BREAKPOINTS = {
  lg: 1200,
  md: 996,
  sm: 768,
  xs: 480,
  xxs: 0
};

var RootObjectFieldTemplate = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(RootObjectFieldTemplate, _React$Component);

  function RootObjectFieldTemplate() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      breakpoint: null,
      row: null
    });

    _defineProperty(_assertThisInitialized(_this), "grid", _react["default"].createRef());

    _defineProperty(_assertThisInitialized(_this), "handleLayoutChange", function (props) {
      console.log(props);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBreakpointChange", function (breakpoint, row) {
      if (_this.state.breakpoint === breakpoint) {
        return;
      }

      _this.grid.forceUpdate();

      _this.setState({
        breakpoint: breakpoint,
        row: row,
        loading: true
      });

      process.nextTick(function () {
        _this.setState({
          loading: false
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderChild", function (childProp) {
      var gridLayout = childProp.content.props.uiSchema.layout;

      var responsiveGridLayout = _lodash["default"].omit(gridLayout, ["sm", "md", "lg"]);

      if (_this.state.breakpoint) {
        var breakpointGridLayout = _lodash["default"].get(gridLayout, _this.state.breakpoint);

        responsiveGridLayout = breakpointGridLayout || responsiveGridLayout;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        key: childProp.name,
        "data-grid": responsiveGridLayout
      }, childProp.content);
    });

    return _this;
  }

  var _proto = RootObjectFieldTemplate.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.grid.forceUpdate();
    this.setState({
      loading: true
    });
    process.nextTick(function () {
      _this2.setState({
        loading: false
      });
    });
  };

  _proto.renderGridLayout = function renderGridLayout() {
    var _this3 = this;

    var props = this.props;

    var cols = _lodash["default"].get(props, "uiSchema.ui:options.cols");

    var breakpoints = _lodash["default"].get(props, "uiSchema.ui:options.breakpoints");

    return /*#__PURE__*/_react["default"].createElement(ResponsiveGridLayout, {
      ref: function ref(grid) {
        _this3.grid = grid;
      },
      layout: "layout",
      breakpoints: _lodash["default"].isObject(breakpoints) ? breakpoints : DEFAULT_BREAKPOINTS,
      cols: _lodash["default"].isObject(cols) ? cols : DEFAULT_COLS,
      autoSize: true,
      onBreakpointChange: this.handleBreakpointChange,
      onLayoutChange: this.handleLayoutChange,
      rowHeight: 150,
      isResizable: false,
      isDraggable: false
    }, props.properties.map(function (childProp) {
      return _this3.renderChild(childProp);
    }));
  };

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
      dangerouslySetInnerHTML: {
        __html: this.props.uiSchema.$header
      }
    }), !this.state.loading && this.renderGridLayout());
  };

  return RootObjectFieldTemplate;
}(_react["default"].Component);

var _default = RootObjectFieldTemplate;
exports["default"] = _default;
module.exports = exports.default;