"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDropzone = _interopRequireDefault(require("react-dropzone"));

var _lodash = _interopRequireDefault(require("lodash"));

var _FileDisplay = _interopRequireDefault(require("./components/FileDisplay"));

var _reactBootstrap = require("react-bootstrap");

var _reactImageFileResizer = _interopRequireDefault(require("react-image-file-resizer"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ReactDropZoneWidget(props) {
  var isReading = props.isReading,
      onAcceptedFiles = props.onAcceptedFiles,
      onChange = props.onChange,
      imageSettings = props.imageSettings,
      isPhotoGallery = props.isPhotoGallery;

  var _useState = (0, _react.useState)(false),
      saving = _useState[0],
      setSaving = _useState[1];

  var acceptedFiles = _lodash["default"].get(props, "options.accepted");

  var originalValue = _lodash["default"].isArray(props.value) ? props.value : [];

  var resizeFile = function resizeFile(file) {
    return new Promise(function (resolve) {
      _reactImageFileResizer["default"].imageFileResizer(file, _lodash["default"].get(imageSettings, "maxWidth") || 1000, _lodash["default"].get(imageSettings, "maxHeight") || 1000, "PNG", _lodash["default"].get(imageSettings, "quality") || 90, 0, function (uri) {
        resolve(uri);
      }, "file");
    });
  };

  var _onDrop = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee3(acceptedFiles) {
      var processedFiles;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              processedFiles = _lodash["default"].map(acceptedFiles, /*#__PURE__*/function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(file) {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!["image/jpeg", "image/png"].includes(file.type)) {
                            _context.next = 4;
                            break;
                          }

                          _context.next = 3;
                          return resizeFile(file);

                        case 3:
                          file = _context.sent;

                        case 4:
                          return _context.abrupt("return", file);

                        case 5:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x2) {
                  return _ref2.apply(this, arguments);
                };
              }());
              setSaving(true);
              Promise.all(processedFiles).then( /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(processedFiles) {
                  return _regenerator["default"].wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          _context2.prev = 0;

                          if (!(processedFiles.length > 0 && onAcceptedFiles)) {
                            _context2.next = 6;
                            break;
                          }

                          _context2.next = 4;
                          return onAcceptedFiles([].concat(originalValue, processedFiles), props);

                        case 4:
                          _context2.next = 9;
                          break;

                        case 6:
                          if (!(processedFiles.length > 0 && onChange)) {
                            _context2.next = 9;
                            break;
                          }

                          _context2.next = 9;
                          return onChange([].concat(originalValue, processedFiles));

                        case 9:
                          _context2.next = 14;
                          break;

                        case 11:
                          _context2.prev = 11;
                          _context2.t0 = _context2["catch"](0);
                          alert(_context2.t0);

                        case 14:
                          _context2.prev = 14;
                          setSaving(false);
                          return _context2.finish(14);

                        case 17:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2, null, [[0, 11, 14, 17]]);
                }));

                return function (_x3) {
                  return _ref3.apply(this, arguments);
                };
              }());

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function _onDrop(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var handleRemove = function handleRemove(item, index) {
    var filteredFiles = _lodash["default"].reject(props.value, function (file, currentIndex) {
      return index === currentIndex;
    });

    props.onChange && props.onChange(filteredFiles);
  };

  var areFilesVisible = _lodash["default"].get(props, "options.withFileDisplay") && !_lodash["default"].isEmpty(props.value);
  return /*#__PURE__*/_react["default"].createElement(_reactDropzone["default"], {
    onDrop: _onDrop,
    accept: isPhotoGallery ? ["image/*"] : acceptedFiles || ["image/*"],
    disabled: saving
  }, function (_ref4) {
    var getRootProps = _ref4.getRootProps,
        getInputProps = _ref4.getInputProps,
        isDragActive = _ref4.isDragActive;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("section", {
      className: "d-print-none"
    }, /*#__PURE__*/_react["default"].createElement("div", _extends({
      className: "dropzone " + (isDragActive ? "active" : "")
    }, getRootProps()), /*#__PURE__*/_react["default"].createElement("input", _extends({}, getInputProps(), {
      name: props.id
    })), saving ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "m-auto"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Spinner, {
      size: "sm"
    }), /*#__PURE__*/_react["default"].createElement("span", null, "Handling files... \xA0"), /*#__PURE__*/_react["default"].createElement("span", {
      className: "spinner-border spinner-border-sm text-info",
      role: "status",
      "aria-hidden": "true"
    })) : isDragActive ? /*#__PURE__*/_react["default"].createElement("p", null, "Drop here...") : /*#__PURE__*/_react["default"].createElement("p", null, "Drag and drop files here, or click to select files"))), props.rawErrors && props.rawErrors.map(function (error, i) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: i
      }, error);
    }), areFilesVisible && /*#__PURE__*/_react["default"].createElement(_FileDisplay["default"], {
      files: props.value,
      onRemove: handleRemove
    }));
  });
}

var _default = ReactDropZoneWidget;
exports["default"] = _default;
module.exports = exports.default;