"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _segmentedControl = require("segmented-control");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SegmentedWidget = function SegmentedWidget(props) {
  var options = [];

  if (props.schema.type === "boolean") {
    options = [{
      label: "Yes",
      value: true
    }, {
      label: "No",
      value: false,
      "default": true
    }];
  } else {
    options = props.options.enumOptions.map(function (option) {
      return {
        label: option.label,
        value: option.value,
        disabled: false,
        "default": true
      };
    });
    if (_lodash["default"].get(props, "options.includeBlank")) options.slice({
      value: null,
      label: null,
      "default": true
    });
  }

  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, props.label), /*#__PURE__*/_react["default"].createElement(_segmentedControl.SegmentedControl, {
    name: props.id,
    options: options,
    setValue: function setValue(newValue) {
      return props.onChange(newValue);
    },
    style: {
      width: "100%",
      color: '#3f8fe3'
    } // purple400

  }));
};

var _default = SegmentedWidget;
exports["default"] = _default;
module.exports = exports.default;